# Ansible 2.9
# Control SQL Traffic to ensure Replica writings are up to date.
---
- name: Backup original hba file
  fetch:
    src: "{{ old_datadir }}/pg_hba.conf"
    dest: /var/tmp/backup/pg_hba.conf-{{ inventory_hostname }}
    flat: true
  tags:
    - close-access
    - backup-ori-hba

- name: Closing SQL traffic with new hba file
  template:
    src: pg_hba.conf.closed.j2
    dest: "{{ old_datadir }}/pg_hba.conf"
    owner: "{{ user }}"
    group: "{{ user }}"
    mode: '0600'
    backup: true
  tags:
    - close-access
    - replace-hba

- name: Reloading PostgreSQL config
  postgresql_query:
    db: postgres
    login_host: "{{ ansible_default_ipv4.address }}"
    login_user: "{{ pguser }}"
    login_password: "{{ mysecretpass }}"
    query: SELECT pg_reload_conf()
  register: reload
  tags:
    - close-access
    - reload-config

- name: Killing active connections
  postgresql_query:
    db: postgres
    login_host: "{{ ansible_default_ipv4.address }}"
    login_user: "{{ pguser }}"
    login_password: "{{ mysecretpass }}"
    query: SELECT pg_terminate_backend(pid)
     FROM pg_stat_activity WHERE datname = %s
    positional_args:
      - "{{ database }}"
  tags:
    - close-access
    - kill-active-conn

- name: Get active connections
  postgresql_query:
    db: postgres
    login_host: "{{ ansible_default_ipv4.address }}"
    login_user: "{{ pguser }}"
    login_password: "{{ mysecretpass }}"
    query: SELECT * FROM pg_stat_activity WHERE datname = %s
    positional_args:
      - "{{ database }}"
  register: activity
  tags:
    - close-access
    - check-active-conn

- name: Verify clients connected
  debug:
    msg:
      - "{% if activity.query_result|length==0 %} The Server is ready
      {% else %} Review the connections before proceed {% endif %}"
  tags:
    - check-active-conn
    - close-access

- name: waiting for CHECKPOINT to complete before stopping postgresql
  become: true
  become_user: root
  command: "gitlab-psql -c 'CHECKPOINT'"
  register: checkpoint_result
  until: checkpoint_result.rc == 0
  retries: 60
  delay: 10
